﻿namespace jello
{
    static class ValueInterpreter
    {
        static public int Interpret(string val, ref InternalState state)
        {
            short inter = 0;
            if (short.TryParse(val, out inter))
                return inter;
            else if (val == "REG")
                return state.Register;
            else if (val == "INP")
                return state.Input;
            else if (val == "OUT")
                return state.Output;
            else if (val.Substring(0, 4) == "MEM(" && val.Substring(val.Length-1, 1) == ")")
            {
                short index = 0;
                if(short.TryParse(val.Replace("MEM(","").Replace(")",""), out index))
                    return state.GetMemory(index);
            }
            return 0;
        }

        static public string InterpretWithFallbackReturn(string val, ref InternalState state)
        {
            short inter = 0;
            if (short.TryParse(val, out inter))
                return inter.ToString();
            else if (val == "REG")
                return state.Register.ToString();
            else if (val == "INP")
                return state.Input.ToString();
            else if (val == "OUT")
                return state.Output.ToString();
            else if (val.Substring(0, 4) == "MEM(" && val.Substring(-1, 1) == ")")
            {
                short index = 0;
                if (short.TryParse(val.Replace("MEM(", "").Replace(")", ""), out index))
                    return state.GetMemory(index).ToString();
            }
            return val;
        }
    }
}
